#-*- mode: python; mode: fold -*-
##parameters=
# $Id: getWAeUPLayouts.py 182 2005-11-16 23:30:12Z joachim $
"""Return custom layouts types."""

##def widget(type = 'String Widget',
##            'data': {
##                'title': '',
##                'fields': ('nr_of_floors',),
##                'is_required': True,
##                'label': 'Nr of Floors ',
##                'label_edit': 'Nr of Floors',
##                'description': '',
##                'help': 'Number of floors per block',
##                'is_i18n': False,
##                'readonly_layout_modes': [],
##                'hidden_layout_modes': [],
##                'hidden_readonly_layout_modes': [],
##                'hidden_empty': 0,
##                'hidden_if_expr': '',
##                'widget_mode_expr': '',
##                'css_class': '',
##                'css_class_expr': '',
##                'javascript_expr': '',
##                'vocabulary': 'range5',
##                'translated': False,
##            },
##        },

Heading = { ###(
         'type': 'Heading Widget',
         'data': {
                'fields': ['heading'],
                'level': 1,
                'is_i18n': 0,
                'is_required': 1,
                'label_edit': 'Headline',
                'help': 'Short Headline',
                'display_width': 40,
                'size_max': 200,
            },
        }###)

Text = { ###(
            'type': 'Text Widget',
            'data': {
                'fields': ['text'],
                'is_i18n': 1,
                'label_edit': 'Text',
                'label': 'Text',
                'help': 'Short Description',
                'css_class': 'description',
                'width': 72,
                'height': 5,
                'render_format': 'text',
                'hidden_layout_modes': (),
            },
        }###)

Title = { ###(
         'type': 'String Widget',
         'data': {
                'fields': ['Title'],
                'is_i18n': 0,
                'is_required': 1,
                'label': 'Title',
                'label_edit': 'Title',
                'display_width': 40,
                'size_max': 200,
            },
        }###)

sc_id = { ###(
        'type': 'String Widget',
        'data': {
                'title': 'SC ID',
                'fields': ('sc_id'),
                'is_required': False,
                'label': 'Card Serial Number ',
                'label_edit': 'Card Serial Number',
                'description': 'Card Serial Number ',
                'help': 'This can be found on the bottom right of the reverse side of your Scratch Card',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:1',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            }
        }
###)

sc_pin = { ###(
         'type': 'Scratchcard Pin Widget',
         'data': {
                'title': 'SC PIN',
                'fields': ('sc_pin'),
                'is_required': True,
                'label': 'enter  PIN',
                'label_edit': 'Enter an Accommodation PIN',
                'description': '',
                'help': 'Please enter a PIN valid for Accomodation booking',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        }
###)

sc_value = { ###(
         'type': 'Float Widget',
         'data': {
                'title': 'Scratch card value',
                'fields': ('sc_value',),
                'is_required': True,
                'label': 'SC Value',
                'label_edit': 'Scratcard Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        }
###)

Description = { ###(
            'type': 'Text Widget',
            'data': {
                'fields': ['Description'],
                'is_i18n': 1,
                'label_edit': 'Description',
                'label': 'Description',
                'css_class': 'description',
                'width': 72,
                'height': 5,
                'render_format': 'text',
                'hidden_layout_modes': (),
            },
        }###)

common_layout = {###(
    'widgets': {
        'LanguageSelector': {
            'type': 'Document Language Select Widget',
            'data': {
                'fields': ['Language'],
            },
        },
        'Title': Title,
        'Description': Description,
        'LanguageSelectorCreation': {
            'type': 'Select Widget',
            'data': {
                'title': 'Language',
                'fields': ('Language',),
                'is_required': 0,
                'label': 'label_language',
                'label_edit': 'label_language',
                'description': '',
                'help': '',
                'is_i18n': 0,
                'readonly_layout_modes': (),
                'hidden_layout_modes': ('create','edit', 'view'),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': 0,
                'hidden_if_expr': '',
                'css_class': '',
                'vocabulary': 'language_voc',
            },
        },
    },
    'layout': {
        'style_prefix': 'layout_waeup_',
        'rows': [
            #[{'widget_id': 'LanguageSelector'}],
            [{'widget_id': 'Title'},],
            [{'widget_id': 'Description'},],
            #[{'widget_id': 'LanguageSelectorCreation'}],
            ],
        },
    }
#
###)

firstname = { ###(
            'type': 'String Widget',
            'data': {
                'title': 'First Name',
                'fields': ('firstname',),
                'is_required': False,
                'label': 'First Name',
                'label_edit': 'First Name',
                'description': 'First Name',
                'help': '',
                'is_i18n': False,
                'display_width': 40,
                },
            }

###)

middlename = { ###(
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('middlename',),
                'is_required': False,
                'label': 'Middle Name',
                'label_edit': 'Middle Name',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': True,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 40,
                'size_max': 0,
                },
            }

###)

lastname = { ###(
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('lastname',),
                'is_required': False,
                'label': 'Surname',
                'label_edit': 'Surname',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 40,
                'size_max': 0,
            },
        }

###)

email = { ###(
            'type': 'Email Widget',
            'data': {
                'title': 'Email',
                'fields': ('email',),
                'is_required': True,
                'label': 'Email',
                'label_edit': 'Email',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 40,
                },
            }
###)

sex = { ###(
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('sex',),
                'is_required': False,
                'label': 'Sex',
                'label_edit': 'Sex',
                'label_false': 'male',
                'label_true': 'female',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            }
        }

###)

pw = { ###(
            'type': 'Password Widget',
            'data': {
                'title': 'Password',
                'fields': ('pw',),
                'is_required': False,
                'label': 'New Password',
                'label_edit': 'New Password',
                'description': '',
                'help': 'Enter a New Password',
                'is_i18n': 0,
                'readonly_layout_modes': [],
                'hidden_layout_modes': [],
                'hidden_readonly_layout_modes': [],
                'hidden_empty': 0,
                'hidden_if_expr': '',
                'widget_mode_expr': '',
                'css_class': '',
                'css_class_expr': '',
                'javascript_expr': '',
                'display_width': 12,
                'size_max': 8,
                'password_widget': '',
                'check_lower': 0,
                'check_upper': 0,
                'check_digit': 0,
                'check_extra': 0,
                'size_min': 5,
            },
        }###)

rpw = { ###(
            'type': 'Password Widget',
            'data': {
                'title': 'confirm Password',
                'fields': ('rpw',),
                'is_required': False,
                'label': 'Confirm Password',
                'label_edit': 'Confirm Password',
                'description': '',
                'help': 'Confirm the New Password',
                'is_i18n': False,
                'display_width': 12,
                'size_max': 8,
                'password_widget': 'pw',
                'check_lower': 0,
                'check_upper': 0,
                'check_digit': 0,
                'check_extra': 0,
                'size_min': 5,
                },
            }###)

username_hidden = { ###(
            'type': 'String Widget',
            'data': {
                'title': 'Username',
                'fields': ('username',),
                'hidden_layout_modes': ['create',],
                },
            }

###)

student_layout = { ###(
    'widgets': {
        'jamb_is_admitted': {
            'type': 'Boolean Widget',
            'data': {
                'title': 'JAMB Admission',
                'fields': ('jamb_is_admitted',),
                'is_required': False,
                'label': 'JAMB Admission',
                'label_edit': 'JAMB Admission',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },

        'faculty': {
            'type': 'String Widget',
            'data': {
                'title': 'Faculty',
                'fields': ('faculty',),
                'is_required': False,
                'label': 'Faculty',
                'label_edit': 'Faculty',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
        'accommodation': {
            'type': 'String Widget',
            'data': {
                'title': 'Accommodation',
                'fields': ('accommodation',),
                'is_required': False,
                'label': 'Accommodation',
                'label_edit': 'Accommodation',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
        'accommodation_sc_id': { ###(
            'type': 'String Widget',
            'data': {
                'title': 'Accommodation SC ID',
                'fields': ('accommodation_sc_id',),
                'is_required': False,
                'label': 'Accommodation SC ID',
                'label_edit': 'Accommodation SC ID',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'accommodation_sc_pin': { ###(
            'type': 'String Widget',
            'data': {
                'title': 'Accommodation SC PIN',
                'fields': ('accommodation_sc_pin',),
                'is_required': False,
                'label': 'Accommodation SC PIN',
                'label_edit': 'Accommodation SC PIN',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'accommodation_sc_value': { ###(
            'type': 'Float Widget',
            'data': {
                'title': 'Accommodation SC Value',
                'fields': ('accommodation_sc_value',),
                'is_required': False,
                'label': 'Accommodation SC Value',
                'label_edit': 'Accommodation SC Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'accommodation_date': { ###(
            'type': 'DateTime Widget',
            'data': {
                'title': 'Accommodation SC PIN',
                'fields': ('accommodation_date',),
                'is_required': False,
                'label': 'Accommodation SC Date',
                'label_edit': 'Accommodation SC Date',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'hostel_fee_sc_id': { ###(
            'type': 'String Widget',
            'data': {
                'title': 'hostel_fee SC ID',
                'fields': ('hostel_fee_sc_id',),
                'is_required': False,
                'label': 'Hostel Fee SC ID',
                'label_edit': 'Hostel Fee SC ID',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'hostel_fee_sc_pin': { ###(
            'type': 'String Widget',
            'data': {
                'title': 'hostel_fee SC PIN',
                'fields': ('hostel_fee_sc_pin',),
                'is_required': False,
                'label': 'Hostel Fee SC PIN',
                'label_edit': 'Hostel Fee SC PIN',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'hostel_fee_sc_value': { ###(
            'type': 'Float Widget',
            'data': {
                'title': 'hostel_fee SC Value',
                'fields': ('hostel_fee_sc_value',),
                'is_required': False,
                'label': 'Hostel Fee SC Value',
                'label_edit': 'Hostel Fee SC Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'hostel_fee_date': { ###(
            'type': 'DateTime Widget',
            'data': {
                'title': 'hostel_fee SC PIN',
                'fields': ('hostel_fee_date',),
                'is_required': False,
                'label': 'Hostel Fee SC Date',
                'label_edit': 'Hostel Fee SC Date',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'adm_check_sc_id': { ###(
            'type': 'String Widget',
            'data': {
                'title': 'Admission check SC ID',
                'fields': ('adm_check_sc_id',),
                'is_required': False,
                'label': 'Admission check SC ID',
                'label_edit': 'Admission check SC ID',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'adm_check_sc_pin': { ###(
            'type': 'String Widget',
            'data': {
                'title': 'Admission check SC PIN',
                'fields': ('adm_check_sc_pin',),
                'is_required': False,
                'label': 'Admission check SC PIN',
                'label_edit': 'Admission check SC PIN',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'adm_check_sc_value': { ###(
            'type': 'Float Widget',
            'data': {
                'title': 'Admission check SC Value',
                'fields': ('adm_check_sc_value',),
                'is_required': False,
                'label': 'Admission check SC Value',
                'label_edit': 'Admission check SC Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'adm_check_date': { ###(
            'type': 'DateTime Widget',
            'data': {
                'title': 'Admission check SC PIN',
                'fields': ('adm_check_date',),
                'is_required': False,
                'label': 'Admission check SC Date',
                'label_edit': 'Admission check SC Date',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'clearance_sc_id': { ###(
            'type': 'String Widget',
            'data': {
                'title': 'Clearance SC ID',
                'fields': ('clearance_sc_id',),
                'is_required': False,
                'label': 'Clearance SC ID',
                'label_edit': 'Clearance SC ID',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'clearance_sc_pin': { ###(
            'type': 'String Widget',
            'data': {
                'title': 'clearance SC PIN',
                'fields': ('clearance_sc_pin',),
                'is_required': False,
                'label': 'Clearance SC PIN',
                'label_edit': 'Clearance SC PIN',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'clearance_sc_value': { ###(
            'type': 'Float Widget',
            'data': {
                'title': 'clearance SC Value',
                'fields': ('clearance_sc_value',),
                'is_required': False,
                'label': 'Clearance SC Value',
                'label_edit': 'Clearance SC Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
        'clearance_date': { ###(
            'type': 'DateTime Widget',
            'data': {
                'title': 'clearance SC PIN',
                'fields': ('clearance_date',),
                'is_required': False,
                'label': 'Clearance SC Date',
                'label_edit': 'Clearance SC Date',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },###)
    },
    'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'adm_check_sc_id', 'ncols': 1},],
            [{'widget_id': 'adm_check_sc_pin', 'ncols': 1},],
            [{'widget_id': 'adm_check_sc_value', 'ncols': 1},],
            [{'widget_id': 'adm_check_date', 'ncols': 1},],
            [{'widget_id': 'clearance_sc_id', 'ncols': 1},],
            [{'widget_id': 'clearance_sc_pin', 'ncols': 1},],
            [{'widget_id': 'clearance_sc_value', 'ncols': 1},],
            [{'widget_id': 'clearance_date', 'ncols': 1},],
            [{'widget_id': 'accommodation', 'ncols': 1},],
            [{'widget_id': 'accommodation_sc_id', 'ncols': 1},],
            [{'widget_id': 'accommodation_sc_pin', 'ncols': 1},],
            [{'widget_id': 'accommodation_sc_value', 'ncols': 1},],
            [{'widget_id': 'accommodation_date', 'ncols': 1},],
            [{'widget_id': 'hostel_fee_sc_id', 'ncols': 1},],
            [{'widget_id': 'hostel_fee_sc_pin', 'ncols': 1},],
            [{'widget_id': 'hostel_fee_sc_value', 'ncols': 1},],
            [{'widget_id': 'hostel_fee_date', 'ncols': 1},],
        ]
    },
}###)

student_personal_layout = { ###(
    'widgets': {
        'firstname': firstname,
        'middlename': middlename,
        'lastname': lastname,
        'email': email,
        'sex': sex,
        'birthday': {
            'type': 'Date Widget',
            'data': {
                'title': '',
                'fields': ('birthday',),
                'is_required': False,
                'label': 'Day of birth',
                'label_edit': 'Day of birth',
                'description': 'Day of birth',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
    },
    'layout': {
        'style_prefix': 'layout_personal_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'firstname', 'ncols': 1},],
            [{'widget_id': 'middlename', 'ncols': 1},],
            [{'widget_id': 'lastname', 'ncols': 1},],
            [{'widget_id': 'email', 'ncols': 1},],
            [{'widget_id': 'sex', 'ncols': 1},],
            [{'widget_id': 'birthday', 'ncols': 1},],
        ]
    },
}###)

student_personal_addon = { ###(
    'widgets': {
        'firstname': middlename,
        'middlename': middlename,
        'lastname': lastname,
        'sex': sex,
        'email': email,
        'username': username_hidden,
        'pw': pw,
        'rpw': rpw,
    },
    'layout': {
        'style_prefix': 'layout_eligibility_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'firstname', 'ncols': 1},],
            #[{'widget_id': 'middlename', 'ncols': 1},],
            #[{'widget_id': 'lastname', 'ncols': 1},],
            #[{'widget_id': 'username', 'ncols': 1},],
            [{'widget_id': 'email', 'ncols': 1},],
            #[{'widget_id': 'pw', 'ncols': 1},],
            #[{'widget_id': 'rpw', 'ncols': 1},],
        ]
    },
}###)

schoolresults = { ###(
            'type': 'Ordered List Widget',
            'data': {
                'title': '',
                'fields': ['schoolresults'],
                'is_required': 0,
                'label': 'School Results',
                'label_edit': 'School Results',
                'description': '',
                'help': '',
                'is_i18n': 0,
                'readonly_layout_modes': [],
                'hidden_layout_modes': ['create','edit'],
                'hidden_readonly_layout_modes': [],
                'hidden_empty': 0,
                'hidden_if_expr': '',
                'widget_mode_expr': '',
                'css_class': '',
                'css_class_expr': '',
                'javascript_expr': '',
                'width': 40,
                'height': 5,
                'format_empty': '',
            },
        }###)

eli_widgets = { ###(
        'jamb_results': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('jamb_results',),
                'is_required': False,
                'label': 'JAMB Results',
                'label_edit': 'JAMB Results',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },
        'jamb_aggregate': {
            'type': 'Int Widget',
            'data': {
                'title': 'Agregate',
                'fields': ('jamb_aggregate',),
                'is_required': False,
                'label': 'Score',
                'label_edit': 'Score',
                'description': '',
                'help': '',
                'is_i18n': False,
            },
        },
        'jamb_listing_date': {
            'type': 'Date Widget',
            'data': {
                'title': 'Listing Date',
                'fields': ('jamb_listing_date',),
                'is_required': False,
                'label': 'Listing Date',
                'label_edit': 'Listing Date',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 3,
                'size_max': 0,
            },
        },
        'faculty': {
            'type': 'Select Widget',
            'data': {
                'title': 'Faculty',
                'fields': ('faculty',),
                'is_required': True,
                'label': 'Faculty',
                'label_edit': 'Faculty',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'get_faculties_voc',
            },
        },
        'course': {
            'type': 'Select Widget',
            'data': {
                'title': 'Study Course',
                'fields': ('course',),
                'is_required': True,
                'label': 'Study Course',
                'label_edit': 'Study Course',
                'description': '',
                'help': 'The course to study',
                'vocabulary': 'get_departments_voc',
                'is_i18n': False,
            },
        },
        'schoolresults': schoolresults,
    }###)

    
student_eligibility = { ###(
    'widgets': eli_widgets,
    'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'jamb_results', 'ncols': 1},],
            [{'widget_id': 'jamb_aggregate', 'ncols': 1},],
            [{'widget_id': 'jamb_listing_date', 'ncols': 1},],
            [{'widget_id': 'faculty', 'ncols': 1},],
            [{'widget_id': 'course', 'ncols': 1},],
            [{'widget_id': 'schoolresults', 'ncols': 1},],
        ]
    },
}###)

student_eligibility_edit = { ###(
    'widgets': eli_widgets,
    'layout': {
        'style_prefix': 'layout_eligibility_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'jamb_results', 'ncols': 1},],
            [{'widget_id': 'jamb_aggregate', 'ncols': 1},],
            [{'widget_id': 'jamb_listing_date', 'ncols': 1},],
            [{'widget_id': 'faculty', 'ncols': 1},],
            [{'widget_id': 'course', 'ncols': 1},],
            [{'widget_id': 'schoolresults', 'ncols': 1},],
        ]
    },
}###)

student_schoolresults = { ###(
    'widgets': {
        'schoolresults': schoolresults,
    },
    'layout': {
        'style_prefix': 'layout_results_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'jamb_results', 'ncols': 1},],
            #[{'widget_id': 'jamb_aggregate', 'ncols': 1},],
            #[{'widget_id': 'jamb_listing_date', 'ncols': 1},],
            #[{'widget_id': 'faculty', 'ncols': 1},],
            #[{'widget_id': 'course', 'ncols': 1},],
            [{'widget_id': 'schoolresults', 'ncols': 1},],
        ]
    },
}###)

student_documents = { ###(
    'widgets': {
        'photo': { ###(
            'type': 'Photo Widget',
            'data': {
                'title': '',
                'fields': ('photo',),
                'is_required': False,
                'label': 'Personal Picture',
                'label_edit': 'Personal Picture',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'widget_mode_expr': '',
                'css_class': '',
                'css_class_expr': '',
                'javascript_expr': '',
                'deletable': True,
                'size_max': 204800,
                'display_width': 90,
                'display_height': 180,
                'allow_resize': True,
                'render_position': 'left',
                'configurable': 'nothing',
                'keep_original': 1,
            },
        },###)
        'birth_certificate': { ###(
            'type': 'Image Widget',
            'data': {
                'title': '',
                'fields': ('birth_certificate',),
                'is_required': False,
                'label': 'Birth Certificate',
                'label_edit': 'Birth Certificate',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'widget_mode_expr': '',
                'css_class': '',
                'css_class_expr': '',
                'javascript_expr': '',
                'deletable': True,
                'size_max': 204800,
                'display_width': 300,
                'display_height':600,
                'allow_resize': True,
            },
        },###)
        'passport': { ###(
            'type': 'Image Widget',
            'data': {
                'title': '',
                'fields': ('passport',),
                'is_required': False,
                'label': 'scanned Passport',
                'label_edit': 'scanned Passport',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'widget_mode_expr': '',
                'css_class': '',
                'css_class_expr': '',
                'javascript_expr': '',
                'deletable': True,
                'size_max': 204800,
                'display_width': 300,
                'display_height':600,
                'allow_resize': True,
            },
        },###)
        'results_first': { ###(
            'type': 'Image Widget',
            'data': {
                'title': '',
                'fields': ('results_first',),
                'is_required': False,
                'label': '1st Sitting Results',
                'label_edit': '1st Sitting Results',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'widget_mode_expr': '',
                'css_class': '',
                'css_class_expr': '',
                'javascript_expr': '',
                'deletable': True,
                'size_max': 204800,
                'display_width': 300,
                'display_height':600,
                'allow_resize': True,
            },
        },###)
        'results_second': { ###(
            'type': 'Image Widget',
            'data': {
                'title': '',
                'fields': ('results_second',),
                'is_required': False,
                'label': '2nd Sitting Results',
                'label_edit': '2nd Sitting Results',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'widget_mode_expr': '',
                'css_class': '',
                'css_class_expr': '',
                'javascript_expr': '',
                'deletable': True,
                'size_max': 40960,
                'display_width': 300,
                'display_height':600,
                'allow_resize': True,
            },
        },###)
    },
    'layout': {
        'style_prefix': 'layout_personal_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'photo', 'ncols': 1},],
            [{'widget_id': 'birth_certificate', 'ncols': 1},],
            [{'widget_id': 'passport', 'ncols': 1},],
            [{'widget_id': 'results_first', 'ncols': 1},],
            [{'widget_id': 'results_second', 'ncols': 1},],
        ]
    },
}

###)

scratch_card = { ###(
    'widgets': {
        'sc_id': {
            'type': 'String Widget',
            'data': {
                'title': 'SC ID',
                'fields': ('sc_id',),
                'is_required': True,
                'label': 'Scratch card ID',
                'label_edit': 'Scratch card ID',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
        'sc_pin': {
            'type': 'Scratchcard Pin Widget',
            'data': {
                'title': 'SC PIN',
                'fields': ('sc_pin'),
                'is_required': True,
                'label': 'Scratchcard Pin',
                'label_edit': 'Scratchcard Pin',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'reg_nr', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
        ]
    },
}
###)

jamb_id = { ###(
           'type': 'StudentId Widget',
           'data': {
                'title': 'Registration Number',
                'fields': ('reg_nr'),
                'is_required': True,
                'label': 'Registration Number',
                'label_edit': 'Registration Number',
                'description': '',
                'help': 'This is the combination of 8 digits and 2 letters you are assigned when you purchase an examination form.',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
                 },
           }

###)

admission = { ###(
    'widgets': {
        'sc_id': {
            'type': 'String Widget',
            'data': {
                'title': 'SC ID',
                'fields': ('sc_id',),
                'is_required': False,
                'label': 'Card Serial Number ',
                'label_edit': 'Card Serial Number',
                'description': 'Card Serial Number ',
                'help': 'This can be found on the bottom right of the reverse side of your Scratch Card',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
        'sc_value': { ###(
         'type': 'Float Widget',
         'data': {
                'title': 'Scratch card value',
                'fields': ('sc_value',),
                'is_required': False,
                'label': 'SC Value',
                'label_edit': 'Scratcard Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': ('create'),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
        'sc_pin': {
            'type': 'Scratchcard Pin Widget',
            'data': {
                'title': 'SC PIN',
                'fields': ('sc_pin'),
                'is_required': True,
                'label': 'PIN',
                'label_edit': 'PIN',
                'description': '',
                'help': 'PIN-(Personal Identification Number) is an 8 or 12 digit number on the reverse side of the scratch card which you can purchase from many Banks',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },
        'jamb_id' : jamb_id,
    },
   'layout': {
        'style_prefix': 'layout_sc_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_value', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
            [{'widget_id': 'jamb_id', 'ncols': 1},],
        ]
    },
}
###)

clearance = { ###(
    'widgets': {
        'sc_id': {
            'type': 'String Widget',
            'data': {
                'title': 'SC ID',
                'fields': ('sc_id',),
                'is_required': False,
                'label': 'Card Serial Number ',
                'label_edit': 'Card Serial Number',
                'description': 'Card Serial Number ',
                'help': 'This can be found on the bottom right of the reverse side of your Scratch Card',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:1',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            },
        },
        'sc_pin': {
            'type': 'Scratchcard Pin Widget',
            'data': {
                'title': 'SC PIN',
                'fields': ('sc_pin'),
                'is_required': True,
                'label': 'PIN',
                'label_edit': 'PIN',
                'description': '',
                'help': 'PIN-(Personal Identification Number) is an 8 or 12 digit number on the reverse side of the scratch card which you can purchase from many Banks',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },
        'sc_value': { ###(
         'type': 'Float Widget',
         'data': {
                'title': 'Scratch card value',
                'fields': ('sc_value',),
                'is_required': False,
                'label': 'SC Value',
                'label_edit': 'Scratcard Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': ('create'),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
        'lastname': { ###(
         'type': 'String Widget',
         'data': {
                'title': 'Scratch card value',
                'fields': ('lastname',),
                'is_required': False,
                'label': 'Surname',
                'label_edit': 'Surname',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': ('create'),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
        'jamb_id' : jamb_id,
    },
   'layout': {
        'style_prefix': 'layout_sc_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_value', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
            [{'widget_id': 'jamb_id', 'ncols': 1},],
            #[{'widget_id': 'lastname', 'ncols': 1},],
        ]
    },
}
###)

admission_status = { ###(
    'widgets': {
       'quick_search': {
            'type': 'String Widget',
            'data': {
                'title': 'A search string',
                'fields': ('admission_sc_id',),
                'is_required': False,
                'label': 'Quick Search',
                'label_edit': 'Quick Search',
                'description': 'Search',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:0',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },

    },
   'layout': {
        'style_prefix': 'layout_admission_status_',
        'flexible_widgets': (),
        'ncols': 2,
        'rows': [
            [{'widget_id': 'quick_search', 'ncols': 2},],
        ]
    },
}
###)

jamb_widgets = { ###(
        'reg_nr': {
            'type': 'StudentId Widget',
            'data': {
                'title': 'registration nr',
                'fields': ('reg_nr',),
                'is_required': True,
                'label': 'Registration Nr',
                'label_edit': 'Registration Nr',
                'description': 'The student id from JAMB',
                'help': 'The Student ID from JAMB',
                'is_i18n': False,
                'display_width': 10,
                'size_max': 10,
            },
        },
        'firstname': firstname,
        'middlename': middlename,
        'lastname': lastname,
        'age': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('age',),
                'is_required': False,
                'label': 'Age',
                'label_edit': 'Age',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 2,
                'size_max': 2,
            },
        },
        'sex': sex,
        'state': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('state',),
                'is_required': False,
                'label': 'State of Origin',
                'label_edit': 'State of Origin',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'nigerian_states',
            },
        },
        'exam_results': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('exam_results',),
                'is_required': False,
                'label': 'JAMB Results',
                'label_edit': 'JAMB Results',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },
        'aggregate': {
            'type': 'Int Widget',
            'data': {
                'title': 'Agregate',
                'fields': ('aggregate',),
                'is_required': False,
                'label': 'Score',
                'label_edit': 'Score',
                'description': '',
                'help': '',
                'is_i18n': False,
            },
        },
        'faculty': {
            'type': 'Select Widget',
            'data': {
                'title': 'Faculty',
                'fields': ('faculty',),
                'is_required': True,
                'label': 'Faculty',
                'label_edit': 'Faculty',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'get_faculties_voc',
            },
        },
        'course': {
            'type': 'Select Widget',
            'data': {
                'title': 'Study Course',
                'fields': ('course',),
                'is_required': True,
                'label': 'Study Course',
                'label_edit': 'Study Course',
                'description': '',
                'help': '',
                'vocabulary': 'get_departments_voc',
                'is_i18n': False,
            },
        },
        'listing_date': {
            'type': 'Date Widget',
            'data': {
                'title': 'Listing Date',
                'fields': ('listing_date',),
                'is_required': False,
                'label': 'Listing Date',
                'label_edit': 'Listing Date',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 3,
                'size_max': 0,
            },
        },
##        '2nd_choice': { ###(
##            'type': 'String Widget',
##            'data': {
##                'title': 'Second choice',
##                'fields': ('2nd_choice',),
##                'is_required': False,
##                'label': 'Second choice',
##                'label_edit': 'Second choice',
##                'description': '',
##                'help': 'second_choice',
##                'is_i18n': False,
##                'readonly_layout_modes': (),
##                'hidden_layout_modes': (),
##                'hidden_readonly_layout_modes': (),
##                'hidden_empty': False,
##                'hidden_if_expr': '',
##                'css_class': '',
##                'widget_mode_expr': '',
##                'display_width': 20,
##                'size_max': 0,
##            },
##        },
##
##        '3rd_choice': {
##            'type': 'String Widget',
##            'data': {
##                'title': 'Third_choice',
##                'fields': ('3rd_choice',),
##                'is_required': False,
##                'label': 'Third choice',
##                'label_edit': 'Third choice',
##                'description': 'third_choice',
##                'help': 'third_choice',
##                'is_i18n': False,
##                'readonly_layout_modes': (),
##                'hidden_layout_modes': (),
##                'hidden_readonly_layout_modes': (),
##                'hidden_empty': False,
##                'hidden_if_expr': '',
##                'css_class': '',
##                'widget_mode_expr': '',
##                'display_width': 20,
##                'size_max': 0,
##            },
##        },
###)

        'sc_id': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('admission_sc_id',),
                'is_required': False,
                'label': 'Scratch card ID used',
                'label_edit': 'Scratch card ID used',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },
        'sc_pin': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('admission_sc_pin',),
                'is_required': False,
                'label': 'Scratch Card PIN',
                'label_edit': 'Scratch Card PIN',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 20,
                'size_max': 0,
            },
        },
    }
###)

jamb_layoutcreate = { ###(
    'widgets': jamb_widgets,
    'layout': {
        'style_prefix': 'layout_jambcreate_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'reg_nr', 'ncols': 1},],
            [{'widget_id': 'firstname', 'ncols': 1},],
            [{'widget_id': 'middlename', 'ncols': 1},],
            [{'widget_id': 'lastname', 'ncols': 1},],
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            #[{'widget_id': 'sc_pin', 'ncols': 1},],
            [{'widget_id': 'age', 'ncols': 1},],
            [{'widget_id': 'sex', 'ncols': 1},],
            [{'widget_id': 'state', 'ncols': 1},],
            #[{'widget_id': 'exam_results', 'ncols': 1},],
            [{'widget_id': 'aggregate', 'ncols': 1},],
            [{'widget_id': 'faculty', 'ncols': 1},],
            [{'widget_id': 'course', 'ncols': 1},],
            [{'widget_id': 'listing_date', 'ncols': 1},],
            #[{'widget_id': '2nd_choice', 'ncols': 1},],
            #[{'widget_id': '3rd_choice', 'ncols': 1},],
        ]
    },
}
###)

jamb_layout = { ###(
    'widgets': jamb_widgets,
    'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'reg_nr', 'ncols': 1},],
            [{'widget_id': 'firstname', 'ncols': 1},],
            [{'widget_id': 'middlename', 'ncols': 1},],
            [{'widget_id': 'lastname', 'ncols': 1},],
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
            [{'widget_id': 'age', 'ncols': 1},],
            [{'widget_id': 'sex', 'ncols': 1},],
            [{'widget_id': 'state', 'ncols': 1},],
            #[{'widget_id': 'exam_results', 'ncols': 1},],
            [{'widget_id': 'aggregate', 'ncols': 1},],
            [{'widget_id': 'faculty', 'ncols': 1},],
            [{'widget_id': 'course', 'ncols': 1},],
            [{'widget_id': 'listing_date', 'ncols': 1},],
            #[{'widget_id': '2nd_choice', 'ncols': 1},],
            #[{'widget_id': '3rd_choice', 'ncols': 1},],
        ]
    },
}
###)

admission_slip = { ###(
    'widgets': jamb_widgets,
    'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'reg_nr', 'ncols': 1},],
            [{'widget_id': 'firstname', 'ncols': 1},],
            [{'widget_id': 'middlename', 'ncols': 1},],
            [{'widget_id': 'lastname', 'ncols': 1},],
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            #[{'widget_id': 'sc_pin', 'ncols': 1},],
            [{'widget_id': 'age', 'ncols': 1},],
            [{'widget_id': 'sex', 'ncols': 1},],
            [{'widget_id': 'state', 'ncols': 1},],
            #[{'widget_id': 'exam_results', 'ncols': 1},],
            [{'widget_id': 'aggregate', 'ncols': 1},],
            [{'widget_id': 'faculty', 'ncols': 1},],
            [{'widget_id': 'course', 'ncols': 1},],
            [{'widget_id': 'listing_date', 'ncols': 1},],
            #[{'widget_id': '2nd_choice', 'ncols': 1},],
            #[{'widget_id': '3rd_choice', 'ncols': 1},],
        ]
    },
}
###)

course = { ###(
    'widgets': {
        'heading': {
         'type': 'String Widget',
         'data': {
                'fields': ['heading'],
                'is_i18n': 0,
                'is_required': 1,
                'label': 'Title',
                'label_edit': 'Title',
                'help': 'Course Title',
                'display_width': 40,
                'size_max': 40,
            },
        },
        'text': Text,
        'level': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('level',),
                'is_required': True,
                'label': 'Level',
                'label_edit': 'Level',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'courselevel',
            },
        },
        'code': {
            'type': 'String Widget',
            'data': {
                'title': 'Code',
                'fields': ('code',),
                'is_required': True,
                'label': 'Code',
                'label_edit': 'Code',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 10,
                'size_max': 0,
            },
        },
        'semester': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('semester',),
                'is_required': True,
                'label': 'Semester',
                'label_edit': 'Semester',
                'label_false': 'Second Semester',
                'label_true': 'First Semester',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 10,
                'size_max': 0,
            },
        },
        'credit': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('credit',),
                'is_required': True,
                'label': 'Credit',
                'label_edit': 'Credit',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 2,
                'size_max': 0,
            },
        },
        'core_elective': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('core_elective',),
                'is_required': True,
                'label': 'Core or elective',
                'label_edit': 'Core or elective',
                'label_true': 'Core Course',
                'label_false': 'Elective Course',
                'description': '',
                'help': '',
                'is_i18n': False,
                'display_width': 10,
                'size_max': 0,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'heading', 'ncols': 1},],
            #[{'widget_id': 'Title', 'ncols': 1},],
            [{'widget_id': 'text', 'ncols': 1},],
            [{'widget_id': 'level', 'ncols': 1},],
            [{'widget_id': 'code', 'ncols': 1},],
            [{'widget_id': 'semester', 'ncols': 1},],
            [{'widget_id': 'credit', 'ncols': 1},],
            [{'widget_id': 'core_elective', 'ncols': 1},],
        ]
    },
}
###)

course_results = { ###(
    'widgets': {
        'points': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('points',),
                'is_required': False,
                'label': 'Points',
                'label_edit': 'Points',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 3,
                'size_max': 3,
            },
        },
        'grade': {
            'type': 'String Widget',
            'data': {
                'title': '',
                'fields': ('grade'),
                'is_required': False,
                'label': 'Grade',
                'label_edit': 'Grade',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 2,
                'size_max': 1,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'points', 'ncols': 1},],
            [{'widget_id': 'grade', 'ncols': 1},],
        ]
    },
}
###)

accommodation = { ###(
    'widgets': {
        'heading': {
         'type': 'String Widget',
         'data': {
                'fields': ['heading'],
                'level': 2,
                'is_i18n': 0,
                'is_required': 1,
                'label': 'Hall Name',
                'label_edit': 'Hall Name',
                'help': '',
                'display_width': 40,
                'size_max': 40,
            },
        },
        'text': Text,
        'which_sex': {
            'type': 'Boolean Widget',
            'data': {
                'title': '',
                'fields': ('which_sex',),
                'is_required': False,
                'label': 'Sex',
                'label_edit': 'Sex',
                'label_false': 'male',
                'label_true': 'female',
                'description': '',
                'help': '',
                'is_i18n': False,
            },
        },
        'nr_of_blocks': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('nr_of_blocks',),
                'is_required': True,
                'label': 'Nr of Blocks',
                'label_edit': 'Nr of Blocks',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'range10',
            },
        },
        'nr_of_floors': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('nr_of_floors',),
                'is_required': True,
                'label': 'Nr of Floors ',
                'label_edit': 'Nr of Floors',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'range5',
            },
        },
        'rooms_per_floor': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('rooms_per_floor',),
                'is_required': True,
                'label': 'Rooms per Floor',
                'label_edit': 'Rooms per Floor',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'range50',
            },
        },
        'beds_per_room': {
            'type': 'Select Widget',
            'data': {
                'title': '',
                'fields': ('beds_per_room',),
                'is_required': True,
                'label': 'Beds per Room',
                'label_edit': 'Beds per Room',
                'description': '',
                'help': '',
                'is_i18n': False,
                'vocabulary': 'range10',
            },
        },
        'beds_assigned': {
            'type': 'Int Widget',
            'data': {
                'title': '',
                'fields': ('beds_assigned',),
                'is_required': True,
                'label': 'Assigned Beds',
                'label_edit': 'Assigned Beds',
                'description': '',
                'help': 'Number of beds already assigned to students',
                'is_i18n': False,
            },
        },
    },
   'layout': {
        'style_prefix': 'layout_waeup_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            [{'widget_id': 'heading', 'ncols': 1},],
            #[{'widget_id': 'Title', 'ncols': 1},],
            [{'widget_id': 'text', 'ncols': 1},],
            [{'widget_id': 'which_sex', 'ncols': 1},],
            [{'widget_id': 'nr_of_blocks', 'ncols': 1},],
            [{'widget_id': 'nr_of_floors', 'ncols': 1},],
            [{'widget_id': 'rooms_per_floor', 'ncols': 1},],
            [{'widget_id': 'beds_per_room', 'ncols': 1},],
            [{'widget_id': 'beds_assigned', 'ncols': 1},],
        ]
    },
}
###)

study_level = { ###(
    'widgets': {
      'sc_id': { ###(
        'type': 'String Widget',
        'data': {
                'title': 'SC ID',
                'fields': ('sc_id'),
                'is_required': False,
                'label': 'Card Serial Number ',
                'label_edit': 'Card Serial Number',
                'description': 'Card Serial Number ',
                'help': 'This can be found on the bottom right of the reverse side of your Scratch Card',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:1',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            }
        },###)
      'sc_pin': { ###(
         'type': 'Scratchcard Pin Widget',
         'data': {
                'title': 'SC PIN',
                'fields': ('sc_pin'),
                'is_required': True,
                'label': 'Enter  PIN',
                'label_edit': 'Enter Scratchcard Pin with the value above',
                'description': '',
                'help': 'Please enter a Scratchcard Pin valid for Registration of Next Level',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
      'sc_value': { ###(
         'type': 'Float Widget',
         'data': {
                'title': 'Scratch card value',
                'fields': ('sc_value',),
                'is_required': False,
                'label': 'Scratcard Value',
                'label_edit': 'Scratcard Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': ('create'),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
               },
   'layout': {
        'style_prefix': 'layout_slregister_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_value', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
        ]
    },
}###)

accobook = { ###(
    'widgets': {
     'sc_id': { ###(
        'type': 'String Widget',
        'data': {
                'title': 'SC ID',
                'fields': ('sc_id'),
                'is_required': False,
                'label': 'Card Serial Number ',
                'label_edit': 'Card Serial Number',
                'description': 'Card Serial Number ',
                'help': 'This can be found on the bottom right of the reverse side of your Scratch Card',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:1',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            }
        },###)
    'sc_pin': { ###(
         'type': 'Scratchcard Pin Widget',
         'data': {
                'title': 'SC PIN',
                'fields': ('sc_pin'),
                'is_required': True,
                'label': 'enter  PIN',
                'label_edit': 'Enter an Accommodation PIN',
                'description': '',
                'help': 'Enter a PIN valid for Accomodation Booking',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
    'sc_value': { ###(
         'type': 'Float Widget',
         'data': {
                'title': 'Scratch card value',
                'fields': ('sc_value',),
                'is_required': False,
                'label': 'SC Value',
                'label_edit': 'Scratcard Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': ('create'),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
               },
   'layout': {
        'style_prefix': 'layout_sc_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_value', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
        ]
    },
}
###)

accopay = { ###(
    'widgets': {
     'sc_id': { ###(
        'type': 'String Widget',
        'data': {
                'title': 'SC ID',
                'fields': ('sc_id'),
                'is_required': False,
                'label': 'Card Serial Number ',
                'label_edit': 'Card Serial Number',
                'description': 'Card Serial Number ',
                'help': 'This can be found on the bottom right of the reverse side of your Scratch Card',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': 'python:1',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 0,
            }
        },###)
    'sc_pin': { ###(
         'type': 'Scratchcard Pin Widget',
         'data': {
                'title': 'SC PIN',
                'fields': ('sc_pin'),
                'is_required': True,
                'label': 'enter  PIN',
                'label_edit': 'Enter Hostel Payment PIN',
                'description': '',
                'help': 'Enter PIN valid for Paying Hostel Fee',
                'is_i18n': False,
                'readonly_layout_modes': (),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
    'sc_value': { ###(
         'type': 'Float Widget',
         'data': {
                'title': 'Scratch card value',
                'fields': ('sc_value',),
                'is_required': False,
                'label': 'SC Value',
                'label_edit': 'Scratcard Value',
                'description': '',
                'help': '',
                'is_i18n': False,
                'readonly_layout_modes': ('create'),
                'hidden_layout_modes': (),
                'hidden_readonly_layout_modes': (),
                'hidden_empty': False,
                'hidden_if_expr': '',
                'css_class': '',
                'widget_mode_expr': '',
                'display_width': 10,
                'size_max': 10,
            },
        },###)
               },
   'layout': {
        'style_prefix': 'layout_sc_',
        'flexible_widgets': (),
        'ncols': 1,
        'rows': [
            #[{'widget_id': 'sc_id', 'ncols': 1},],
            [{'widget_id': 'sc_value', 'ncols': 1},],
            [{'widget_id': 'sc_pin', 'ncols': 1},],
        ]
    },
}###)

layouts = {}
layouts['university'] = common_layout
layouts['waeup_common'] = common_layout
layouts['student'] = student_layout
layouts['study_level'] = study_level
layouts['student_documents'] = student_documents
layouts['student_personal'] = student_personal_layout
layouts['student_personal_addon'] = student_personal_addon
layouts['student_eligibility'] = student_eligibility
layouts['student_eligibility_edit'] = student_eligibility_edit
layouts['student_schoolresults'] = student_schoolresults
layouts['accommodation'] = accommodation
layouts['accobook'] = accobook
layouts['accopay'] = accopay
layouts['scratch_card'] = scratch_card
layouts['admission'] = admission
layouts['clearance'] = clearance
layouts['admission_slip'] = admission_slip
layouts['jambcreate'] = jamb_layoutcreate
layouts['jamb'] = jamb_layout
layouts['faculty'] = common_layout
layouts['department'] = common_layout
layouts['course'] = course
layouts['admission_status'] = admission_status
return layouts
